from OpenGL.GL import *
from OpenGL.GLU import *
import pygame, pygame.image
from pygame.locals import *

import mouseInfo
import textDraw

CONSOLE_WIDTH=350
WIDGET_SIZE=20

gConsoleDefaultHeight=600.0
gConsoleCurrentHeight=400.0

gMouseInDragger=False

gLines=[]

def drawConsole():
    glColor3f(1,1,1)
    
    glBegin(GL_LINE_STRIP)
    glVertex(0,gConsoleCurrentHeight)
    glVertex(WIDGET_SIZE,gConsoleCurrentHeight-WIDGET_SIZE)
    glVertex(CONSOLE_WIDTH-WIDGET_SIZE,gConsoleCurrentHeight-WIDGET_SIZE)
    glVertex(CONSOLE_WIDTH,gConsoleCurrentHeight)
    glVertex(CONSOLE_WIDTH,600.0)
    glEnd()

    cx=CONSOLE_WIDTH/2
    DRAGGER_WIDTH=3*WIDGET_SIZE
    DRAGGER_HALF_WIDTH=DRAGGER_WIDTH/2
    thumbLeft=cx-DRAGGER_HALF_WIDTH
    thumbRight=cx+DRAGGER_HALF_WIDTH
    cy=gConsoleCurrentHeight-WIDGET_SIZE/2
    glBegin(GL_LINES)
    glVertex(thumbLeft,cy)
    glVertex(thumbRight,cy)
    glVertex(0,gConsoleCurrentHeight)
    glVertex(CONSOLE_WIDTH,gConsoleCurrentHeight)
    glEnd()

    textDraw.drawString(10,gConsoleCurrentHeight+10,
                        (.5,1.0,.5),
                        4,
                        "22:14 tsmaster: The Quick Brown Fox Jumps Over the lazy dog.")

    textDraw.drawString(10,gConsoleCurrentHeight+30,
                        (.5,1.0,.5),
                        4,
                        "Pack my box with five dozen liquor jugs!!")

    textDraw.drawString(10,gConsoleCurrentHeight+50,
                        (1.0,1.0,.5),
                        4,
                        "10 9 8 7 6 5 4... 3.141592654")


def update(dt):
    readMouse()
    if gMouseInDragger:
        gConsoleCurrentHeight=mouseInfo.gMouseY
        gConsoleDefaultHeight=mouseInfo.gMouseY


def reset():
    global gConsoleTime,gLines
    gConsoleTime=0.0
    gLines=[]

def addLine(s):
    wrappedLines=wordWrap(s)

    for w in wrappedLines:
        gLines.append((gConsoleTime, w))

    
def mouseInConsole():
    return (mouseInfo.gMouseX<CONSOLE_WIDTH and
            mouseInfo.gMouseY>gConsoleCurrentHeight-WIDGET_SIZE)
        


