import fsmMgr

import math
import random

from OpenGL.GL import *
from OpenGL.GLU import *
import pygame, pygame.image
from pygame.locals import *

import mouseInfo
import stateFlight
import statePower
import tutorialProgress
import playerMgr
import level1
import textDraw
import stateAim
import stateMainMenu

NUM_DISPLAYED=10

TITLE_SIZE=8
CLICK_MSG="Click To Continue."
CLICK_MSG_SIZE=4

SCORE_SIZE=5
SCORE_SPACE=24

class StateTotalScore(fsmMgr.State):
    def __init__(self, data):
        fsmMgr.State.__init__(self)

        self.clicked=False
        self.dialogTime=0.0

        self.scoreList=[]

    def init(self):
        levelNum=level1.thisLevel.level
        
        for p in playerMgr.gPlayerList:
            totalScore=0
            for levelIndex in p.scores:
                totalScore += p.scores[levelIndex]

            self.scoreList.append((totalScore,p.name))
        self.scoreList.sort()

        for s in self.scoreList:
            print s
            
    def update(self, dt):
        pass


    def handleMouseButton(self, bDown, buttonIndex):
        if bDown==True and buttonIndex==1:
            self.clicked=True

        if bDown==False and buttonIndex==1 and self.clicked:
            fsmMgr.popState()
        return True


    def draw(self):
        textDraw.drawCenteredString(400,550,
                                    (.25, 1, .25),
                                    TITLE_SIZE,
                                    "FINAL STANDINGS")

        y=500

        textDraw.drawString(100,y,
                            (.25,1,.25),
                            SCORE_SIZE,
                            "NAME~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~TOTAL")

        y-=SCORE_SPACE*1.5



        for i,s in enumerate(self.scoreList):
            totalScore,name=s

            nameLen=len(name)
            totalScoreString=str(totalScore)
            totalScoreLen=len(totalScoreString)

            msg=name+"~"*(30-nameLen)
            msg+="~"*(10-totalScoreLen)
            msg+=totalScoreString

            if i==0:
                c=(0.80, 1.0, 0.80)
            else:
                c=(0.25, 1.0, 0.25)
                
            textDraw.drawString(100,y,
                                (.25,1,.25),
                                SCORE_SIZE,
                                msg)

            y-=SCORE_SPACE


        textDraw.drawCenteredString(400,50,
                                    (.25, 1, .25),
                                    CLICK_MSG_SIZE,
                                    CLICK_MSG)
        
        
    def handleMouseButton(self, bDown, buttonIndex):
        #calibrate power next

        if bDown==True and buttonIndex==1:
            self.clicked=True
        if bDown==False and buttonIndex==1 and self.clicked:
            self.done()
        return True

    def handleKey(self, key):
        self.done()
        return True

    def done(self):
        fsmMgr.popAll()
        fsmMgr.pushState(stateMainMenu.StateMainMenu(None))
